#pragma once

#include <Widgets/Definitions.h>
#include <Widgets/Listbox/ListboxBase.h>
#include "../Base.h"
#include "../File.h"
#include "../Game/Animation.h"
#include "ResizableObject.h"

namespace gorgon { namespace widgets {

	class Listbox;

	Listbox *LoadListbox(Base *parent, File &file, std::istream &in, int Size);

	class Listbox : public gge::widgets::listbox::Blueprint, public Base {
		friend Listbox *LoadListbox(gorgon::Base *parent, File &file, std::istream &in, int Size);
	public:

		virtual void Save(std::ostream &out) {
			auto start=WriteObjectStart(out, *this);


			auto propstart=WriteSectionStart(out, gge::widgets::GID::Listbox_Props);

			WriteTo(out, DefaultSize);
			WriteLink(Item, out);
			WriteLink(Header, out);
			WriteLink(Panel, out);
			WriteLink(AltItem, out);
			WriteLink(Footer, out);

			WriteEnd(out, propstart);

			WriteNames(out, *this, gge::widgets::GID::Listbox_Names, gge::widgets::GID::Listbox_Name);
			WriteSubItems(out, *this);


			WriteEnd(out, start);
		}

		virtual GID::Type GetGID() const {
			return gge::widgets::listbox::Blueprint::GetGID();
		}

		virtual void Prepare(gge::GGEMain &main, File &file) {
			Base::Prepare(main,file);

			if(Item || Panel)
				return;

			file.FindObject(item, Item);
			file.FindObject(header, Header);
			file.FindObject(panel, Panel);
			file.FindObject(altitem, AltItem);
			file.FindObject(footer, Footer);
		}

		using gorgon::Base::Subitems;

	};	


}}
